<template>
	<ContentWrap>
		<!-- 搜索工作栏 -->
		<el-form
			class="-mb-15px"
			:model="queryParams"
			ref="queryFormRef"
			:inline="true"
			label-width="68px"
		>
			<el-form-item label="月嫂id" prop="yuesaoId">
				<el-input
					v-model="queryParams.yuesaoId"
					placeholder="请输入月嫂id"
					clearable
					@keyup.enter="handleQuery"
					class="!w-240px"
				/>
			</el-form-item>
			<el-form-item label="订单id" prop="orderId">
				<el-input
					v-model="queryParams.orderId"
					placeholder="请输入订单id"
					clearable
					@keyup.enter="handleQuery"
					class="!w-240px"
				/>
			</el-form-item>
			<!--      <el-form-item label="评价" prop="comment">-->
			<!--        <el-input-->
			<!--          v-model="queryParams.comment"-->
			<!--          placeholder="请输入评价"-->
			<!--          clearable-->
			<!--          @keyup.enter="handleQuery"-->
			<!--          class="!w-240px"-->
			<!--        />-->
			<!--      </el-form-item>-->
			<!--      <el-form-item label="标签" prop="remarks">-->
			<!--        <el-input-->
			<!--          v-model="queryParams.remarks"-->
			<!--          placeholder="请输入标签"-->
			<!--          clearable-->
			<!--          @keyup.enter="handleQuery"-->
			<!--          class="!w-240px"-->
			<!--        />-->
			<!--      </el-form-item>-->
			<!--      <el-form-item label="评分" prop="point">-->
			<!--        <el-input-->
			<!--          v-model="queryParams.point"-->
			<!--          placeholder="请输入评分"-->
			<!--          clearable-->
			<!--          @keyup.enter="handleQuery"-->
			<!--          class="!w-240px"-->
			<!--        />-->
			<!--      </el-form-item>-->
			<el-form-item label="是否显示" prop="isShow">
				<el-select
					v-model="queryParams.isShow"
					placeholder="请是否显示"
					clearable
					@keyup.enter="handleQuery"
					class="!w-240px"
				>
					<el-option label="显示" :value="true"/>
					<el-option label="隐藏" :value="false"/>
				</el-select>
			</el-form-item>
			<el-form-item label="创建时间" prop="createTime">
				<el-date-picker
					v-model="queryParams.createTime"
					value-format="YYYY-MM-DD HH:mm:ss"
					type="daterange"
					start-placeholder="开始日期"
					end-placeholder="结束日期"
					:default-time="[new Date('1 00:00:00'), new Date('1 23:59:59')]"
					class="!w-240px"
				/>
			</el-form-item>
			<el-form-item>
				<el-button @click="handleQuery">
					<Icon icon="ep:search" class="mr-5px"/>
					搜索
				</el-button>
				<el-button @click="resetQuery">
					<Icon icon="ep:refresh" class="mr-5px"/>
					重置
				</el-button>
				<el-button
					type="primary"
					plain
					@click="openForm('create')"
					v-hasPermi="['yuesao:order-evaluate:create']"
				>
					<Icon icon="ep:plus" class="mr-5px"/>
					新增
				</el-button>
				<el-button
					type="success"
					plain
					@click="handleExport"
					:loading="exportLoading"
					v-hasPermi="['yuesao:order-evaluate:export']"
				>
					<Icon icon="ep:download" class="mr-5px"/>
					导出
				</el-button>
			</el-form-item>
		</el-form>
	</ContentWrap>

	<!-- 列表 -->
	<ContentWrap>
		<el-table v-loading="loading" :data="list" :stripe="true">
			<el-table-column label="ID" align="center" prop="id"/>
			<el-table-column label="月嫂id" align="center" prop="yuesaoId"/>
			<el-table-column label="订单id" align="center" prop="orderId"/>
			<el-table-column label="评价" align="center" prop="comment"/>
			<el-table-column label="标签" align="center" prop="remarksArray"/>
			<el-table-column label="评分" align="center" prop="point"/>
			<el-table-column label="是否显示 0=不显示 1=显示" align="center" prop="isShow">
				<template #default="{row}">
					{{ row.isShow ? '显示' : '隐藏' }}
				</template>
			</el-table-column>
			<el-table-column label="评价图片" align="center" prop="picUrl" min-width="360px">
				<template #default="{row}">
					<viewer :images="JSON.parse(row.picUrl)"
					        style="display:flex; align-items: center;align-items: center; flex-wrap: wrap">
						<img style="width: 100px; height: 100px; object-fit: contain; margin: 8px 8px 0 0; border: 1px dashed #ccc;"
						     v-for="img in JSON.parse(row.picUrl)" :src="img" :key="img" alt=""/>
					</viewer>
				</template>
			</el-table-column>
			<el-table-column
				label="创建时间"
				align="center"
				prop="createTime"
				:formatter="dateFormatter"
				width="180px"
			/>
			<el-table-column label="操作" align="center" min-width="200px" fixed="right">
				<template #default="scope">
					<!--          <el-button-->
					<!--            link-->
					<!--            type="primary"-->
					<!--            @click="openForm('update', scope.row.id)"-->
					<!--            v-hasPermi="['yuesao:order-evaluate:update']"-->
					<!--          >-->
					<!--            编辑-->
					<!--          </el-button>-->
					<!--          <el-button-->
					<!--            link-->
					<!--            type="danger"-->
					<!--            @click="handleDelete(scope.row.id)"-->
					<!--            v-hasPermi="['yuesao:order-evaluate:delete']"-->
					<!--          >-->
					<!--            删除-->
					<!--          </el-button>-->
					<el-button
						link
						type="primary"
						@click="handleAudit(scope.row.id, true)"
					>
						设为显示
					</el-button>
					<el-button
						link
						type="danger"
						@click="handleAudit(scope.row.id, false)"
					>
						设为隐藏
					</el-button>
				</template>
			</el-table-column>
		</el-table>
		<!-- 分页 -->
		<Pagination
			:total="total"
			v-model:page="queryParams.pageNo"
			v-model:limit="queryParams.pageSize"
			@pagination="getList"
		/>
	</ContentWrap>

	<!-- 表单弹窗：添加/修改 -->
	<OrderEvaluateForm ref="formRef" @success="getList"/>
</template>

<script setup lang="ts">
import {dateFormatter} from '@/utils/formatTime'
import download from '@/utils/download'
import * as OrderEvaluateApi from '@/api/yuesao/orderEvaluate'
import OrderEvaluateForm from './OrderEvaluateForm.vue'
import {auditEvaluate} from "@/api/yuesao/orderEvaluate";

defineOptions({name: 'OrderEvaluate'})

const message = useMessage() // 消息弹窗
const {t} = useI18n() // 国际化

const loading = ref(true) // 列表的加载中
const total = ref(0) // 列表的总页数
const list = ref([]) // 列表的数据
const queryParams = reactive({
	pageNo: 1,
	pageSize: 10,
	parentId: null,
	yuesaoId: null,
	orderId: null,
	comment: null,
	remarks: null,
	point: null,
	isShow: null,
	picUrl: null,
	createTime: []
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中

/** 查询列表 */
const getList = async () => {
	loading.value = true
	try {
		const data = await OrderEvaluateApi.getOrderEvaluatePage(queryParams)
		list.value = data.list
		total.value = data.total
	} finally {
		loading.value = false
	}
}

/** 搜索按钮操作 */
const handleQuery = () => {
	queryParams.pageNo = 1
	getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
	queryFormRef.value.resetFields()
	handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
	formRef.value.open(type, id)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
	try {
		// 删除的二次确认
		await message.delConfirm()
		// 发起删除
		await OrderEvaluateApi.deleteOrderEvaluate(id)
		message.success(t('common.delSuccess'))
		// 刷新列表
		await getList()
	} catch {
	}
}

/** 导出按钮操作 */
const handleExport = async () => {
	try {
		// 导出的二次确认
		await message.exportConfirm()
		// 发起导出
		exportLoading.value = true
		const data = await OrderEvaluateApi.exportOrderEvaluate(queryParams)
		download.excel(data, '订单月嫂评价表	.xls')
	} catch {
	} finally {
		exportLoading.value = false
	}
}

// 审核
const handleAudit = async (id, isShow: boolean) => {
	try {
		await OrderEvaluateApi.auditEvaluate({id, isShow})
		message.alert('设置成功')
		getList()
	} catch {
	}
}


/** 初始化 **/
onMounted(() => {
	getList()
})
</script>
